c
c=======================================================================
c  Include file "curflds.h".
c=======================================================================
#ifndef rmdocinc
c
c  Read and/or computed (current) fields to time DCUR.
c
c  DCUR     current time (Julian day or year day).
c  DWDZ     vertical gradient of QG vertical velocity.
c  PBAR     vertically integrated streamfunction (barotropic transport).
c  P_BRY    PE transport streamfuntion boundary conditions.
c  PSI      velocity streamfunction.
c  T        tracer type of variables (temperature, salinity, other).
c  TMEAN    Slowly varying (horizontally averaged) tracer field.
c  U        total u-velocity component.
c  UBAR     vertically integrated, total u-velocity component.
c  UI       internal mode (baroclinic) u-velocity component.
c  V        total v-velocity component.
c  VBAR     vertically integrated, total v-velocity component.
c  VI       internal mode (baroclinic) v-velocity component.
c
c=======================================================================
#endif
c
      common /curflds/ dcur,t,tmean,psi,pbar,u,ubar,ui,v,vbar,vi,dwdz,
     &                 p_bry
      real dcur,dwdz(np,nz),pbar(np),p_bry(mx,4),psi(np,nz),t(np,nz,mt),
     &     tmean(np,nz,mt),u(np,nz),ubar(np),ui(np,nz),v(np,nz),
     &     vbar(np),vi(np,nz)
